searchData={"items":[{"type":"module","title":"Bex","doc":"`Bex` internals and helpers.","ref":"Bex.html"},{"type":"function","title":"Bex.io_diff/2","doc":"IO formatter for diffs","ref":"Bex.html#io_diff/2"},{"type":"function","title":"Examples - Bex.io_diff/2","doc":"iex> Bex.io_diff(\"foo\", :delete)\n    \"- foo\"\n    iex> Bex.io_diff(\"foo\", :add)\n    \"+ foo\"\n    iex> Bex.io_diff(\"foo\", \"→\")\n    \"→ foo\"","ref":"Bex.html#io_diff/2-examples"},{"type":"function","title":"Bex.mfa/1","doc":"Retrieves `mfa` tuple from `Macro.Env`","ref":"Bex.html#mfa/1"},{"type":"function","title":"Examples - Bex.mfa/1","doc":"iex> Bex.mfa(__ENV__)\n    {BexTest, :\"doctest Bex.mfa/1 (1)\", 1}","ref":"Bex.html#mfa/1-examples"},{"type":"function","title":"Bex.telemetry_event_base/1","doc":"Builds a `telemetry` event base name from `Macro.Env`","ref":"Bex.html#telemetry_event_base/1"},{"type":"function","title":"Examples - Bex.telemetry_event_base/1","doc":"iex> Bex.telemetry_event_base(__ENV__)\n    [:bextest, :\"doctest Bex.telemetry_event_base/1 (2)_1\"]","ref":"Bex.html#telemetry_event_base/1-examples"},{"type":"function","title":"Bex.telemetry_measurements_base/1","doc":"Standard `:telemetry.span/3`-like measurements","ref":"Bex.html#telemetry_measurements_base/1"},{"type":"function","title":"Examples - Bex.telemetry_measurements_base/1","doc":"iex> measurements = Bex.telemetry_measurements_base(%{foo: :bar})\n    ...> match?(%{monotonic_time: _, system_time: _, foo: :bar}, measurements)\n    true","ref":"Bex.html#telemetry_measurements_base/1-examples"},{"type":"task","title":"mix bex.config","doc":"Collects the information about all bex-patched behaviours _and_ amends the config file","ref":"Mix.Tasks.Bex.Config.html"},{"type":"task","title":"Allowed arguments - mix bex.config","doc":"- **`--dir: :string`** _[optional, default: `lib/bex`]_ the directory where to look\n  for generated modules\n- **`--patch`** _[optional, default: `true`]_ if `false`, no attempt to patch found occurences\n  of calls to the behavioured function(s) would be made","ref":"Mix.Tasks.Bex.Config.html#module-allowed-arguments"},{"type":"task","title":"Example - mix bex.config","doc":"```sh\nmix bex.config --no-patch\n```","ref":"Mix.Tasks.Bex.Config.html#module-example"},{"type":"task","title":"mix bex.generate","doc":"Mix task to generate the `Bex` wrapping behaviour scaffold.\n\nBy running `mix bex.generate --module ModuleToConvert` or\n`mix bex.generate --function Module.function_to_convert/arity`\ntwo modules are to be generated:\n\n- behaviour module for the functions(s)\n- default implementation module, wrapping the original function(s)","ref":"Mix.Tasks.Bex.Generate.html"},{"type":"task","title":"Allowed arguments - mix bex.generate","doc":"- **`--module: :string`** _or_ **`--function: :string`** _[mandatory]_ the name of the module\n  or the function to convert to behaviour implementation\n- **`--dir: :string`** _[optional, default: `lib/bex`]_ the target directory for generated\n  modules\n- **`--patch`** _[optional, default: `true`]_ if `false`, no attempt to patch found occurences\n  of calls to the behavioured function(s) would be made\n- **`--backup`** _[optional, default: `false`]_ if `true`, the file will be backed up with `.bex`\n  extension before patching\n- **`--test`** _[optional, default: `true`]_ if `false`, tests for patched calls will not be generated\n  (it has no effect with `--no-patch`)","ref":"Mix.Tasks.Bex.Generate.html#module-allowed-arguments"},{"type":"task","title":"Example - mix bex.generate","doc":"```sh\nmix bex.generate --function Process.send_after/4 --no-patch\n```","ref":"Mix.Tasks.Bex.Generate.html#module-example"},{"type":"extras","title":"Bex","doc":"# Bex\n\n**The set of mix tasks to help dealing with behaviours and mocks**","ref":"readme.html"},{"type":"extras","title":"Objective - Bex","doc":"The goal of this library is to make planting better testing into a source code\nas smoothly and fluently as possible. It’s barely needed for experienced developers,\nbut I always find myself struggling to recall all the places in the source code\nI have to amend to convert a bare call into a behaviour-baked implementation.\n\nThe main task `Mix.Tasks.Bex.Generate` would do the following things:\n\n- generate behaviour code for the function(s) given as an argument\n- generate the default implementation for it, wrapping the call to the original code\n  and [optionally] adding `:telemetry` events in the recommended `telemetry.span/3`\n  flavored manner\n- find all the occurrences of the behaviourized call(s) in the source code and patch\n  them in-place (unless `--no-patch` flag is given)\n- generate test(s) for the aforementioned functions, with proper `Mox` allowances\n  (unless `--no-test` flag is given)\n- prompt to amend `config/config.exs` file to use correct implementations in different\n  environments","ref":"readme.html#objective"},{"type":"extras","title":"Use-case - Bex","doc":"Consider the necessity to test the function that calls `Process.send_after/4` function\nin your code. Assuming we trust that `Process.send_after/4` itself works, we’d like to\nmock it and validate the proper call with proper arguments happened.\n\nFor that we might run `Mix.Tasks.Bex.Generate` task, review generated files, and voilà.\nThe next `mix test`, or `mix test test/bex` would execute the tests for the newly created\nbehaviour using `Mox`.","ref":"readme.html#use-case"},{"type":"extras","title":"Usage - Bex","doc":"```elixir\nmix bex.generate --function Process.send_after/4\n```\n\nThe above will generate the behaviour module `Bex.Behaviours.Process` and its default\nimplementation which should be called instead of a direct call to the original function.\n\nAlso `Mox` scaffold and `telemetry` call will be generated.","ref":"readme.html#usage"},{"type":"extras","title":"Installation - Bex","doc":"```elixir\ndef deps do\n  [\n    {:bex, \"~> 0.2\"}\n  ]\nend\n```\n\n## [Documentation](https://hexdocs.pm/bex)","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}